{
bar = new TControlBar("vertical", "GRETINA tracking");
bar->AddButton("compile/load GSUtil",".L GSUtil.cc++");
bar->AddButton("load root file","dload(\"GTDATA/c2.root\")");
bar->AddButton("mkcanvas","mkcanvas()");

//bar->AddButton("display FPGAE spectrum", "d1(\"FPGAE\",0,1500)");
bar->AddButton("display hit pattern", "d1(\"hitpat\",0,130)");
bar->AddButton("display decompSumE spectrum", "d1(\"decompSumE\",0,1500)");
bar->AddButton("display sumTrackE spectrum", "d1(\"sumTrackE\",0,1500)");

bar->AddButton("overlay sumTrackE spectrum", "d1o(\"sumTrackE\",0,1500)");
//bar->AddButton("sum of gates",".x sumgate.cc");
//bar->AddButton("BGS Si energies","d1(\"BGSEsi\",0,15000)");

//bar->AddButton("display BGStac spectrum", "d1(\"BGStac\",-300,100)");
bar->AddButton("display fm spectrum", "d1(\"fm\",0,1500)");
bar->AddButton("display polar angle spectrum", "d1(\"polang\",0,180)");
bar->AddButton("display radius spectrum", "d1(\"radius\",0,30)");
bar->AddButton("display dopplerfac spectrum", "d1(\"dopplerfac\",0.50,1.50)");
bar->AddButton("display EXT tac", "d1(\"EXT_tac\",-400,400)");
bar->AddButton("display S800 PID", "d2(\"S800_PID\")");

bar->AddButton("display sumTrackE FOM<0.2", "pjx(\"fomXe\",\"x\",0,0.2);d1(\"x\",0,1500)");
bar->AddButton("display sumTrackE FOM<0.3", "pjx(\"fomXe\",\"x\",0,0.3);d1(\"x\",0,1500)");
bar->AddButton("display sumTrackE FOM<0.4", "pjx(\"fomXe\",\"x\",0,0.4);d1(\"x\",0,1500)");
bar->AddButton("display sumTrackE FOM<0.5", "pjx(\"fomXe\",\"x\",0,0.5);d1(\"x\",0,1500)");
bar->AddButton("display sumTrackE FOM<0.6", "pjx(\"fomXe\",\"x\",0,0.6);d1(\"x\",0,1500)");
bar->AddButton("display sumTrackE FOM<0.7", "pjx(\"fomXe\",\"x\",0,0.7);d1(\"x\",0,1500)");
bar->AddButton("display sumTrackE FOM<0.8", "pjx(\"fomXe\",\"x\",0,0.8);d1(\"x\",0,1500)");
bar->AddButton("display sumTrackE FOM<1.0", "pjx(\"fomXe\",\"x\",0,1.0);d1(\"x\",0,1500)");
bar->AddButton("display sumTrackE FOM<2.0", "pjx(\"fomXe\",\"x\",0,2.0);d1(\"x\",0,1500)");
bar->AddButton("rebin 2","x->Rebin(2)");
bar->AddButton("rebin 3","x->Rebin(3)");
bar->AddButton("rebin 5","x->Rebin(5)");
bar->AddButton("rebin 7","x->Rebin(7)");
bar->AddButton("smooth","x->Smooth(1)");
bar->AddButton("display G4_obs", "d1(\"G4_obs\",0,1500)");
bar->AddButton("display G4_emit", "d1(\"G4_emit\",0,1500)");
bar->AddButton("write selected spectra", "wrspe(\"decompSumE\",\"decompSumE.spe\"); wrspe(\"sumTrackE\",\"sumTrackE.spe\");wrspe(\"FPGAE\",\"FPGAE.spe\")");
//bar->AddButton("find P/T",".!findPT.sh");
bar->AddButton("display SMAP_allhits", "d2(\"SMAP_allhits\")");
bar->AddButton("display SMAP_firsthits", "d2(\"SMAP_firsthits\")");
bar->AddButton("quit", ".q");
bar->Show();
}
